

public class cvrp_ls {
    public static void main(String[] args) throws Exception {
        String fileLocation = "";
        String algorithm ="none";
        String[] optionalParams = new String[args.length-2];
        System.arraycopy(args, 2, optionalParams, 0, args.length-2);

        try {
            fileLocation = args[0];
            algorithm = args[1];
        } catch (Exception e) {
            System.out.println("Something seems to be wrong with the given parameters");
           
        }


            
  
        //create new instance from file
        Instance instance = new Instance();
        try {
            instance = new Instance(fileLocation);
        } catch (Exception e) {
            System.err.println("Import of instance failed critically");
            e.printStackTrace();
            System.exit(1);
        }
        
        //create initial Greedy Solution
        Algorithms greedy = new Algorithms("greedy", optionalParams);
        Solution greedySolution = greedy.generateSolution(instance);
        System.out.println("Greedy done");

        //optimize with chosen algorithm
        Algorithms chosen = new Algorithms();
        try {
            chosen = new Algorithms(algorithm, optionalParams);
        } catch (Exception e) {
            System.err.println("Not all parameters for this algorithm seem to be right");
        }
        
        Solution optimizedSolution = chosen.generateSolution(greedySolution);
        
        //print results
        if(chosen.algorithmType.equals( "ant_colony") || chosen.algorithmType.equals("greedy")){
            System.out.println(("\nSolved with "+chosen.algorithmType+" with a maximum runtime of approximately "+chosen.maxRuntimeInSeconds+" seconds!").replace("-1", "unlimited"));
            
            if(chosen.algorithmType.equals("ant_colony"))
                System.out.println("Ants: "+chosen.numberOfAnts+", Phermones Added: "+chosen.pheromonesStrength+", Pheromones Decayed: "+ chosen.pheromonesDecayStrength + ", Deploy Strategy: "+chosen.antStartStrategy+", Reset after Major round: "+chosen.resetPheromones);
            System.out.println("Instance name"+" & "+" "+" & "+"Cost solution ("+chosen.algorithmType+")"+" & " + "Cost upper bound (100%)"+ "   \\\\");
            if(instance.getOptimalCost() > 0)
                System.out.println(instance.getName()+" & " + "  & "+optimizedSolution.getCost()+" ("+(float)optimizedSolution.getCost()/(float)instance.getOptimalCost()*100+"%) & "+instance.getOptimalCost() + "   \\\\");
            else
                System.out.println(instance.getName()+" & "+greedySolution.getCost()+" & "+optimizedSolution.getCost()+" & "+ "   \\\\");
            System.out.println("\n Solution:\n"+optimizedSolution.toSol());
        } else {
            System.out.println(("\nAfter initial greedy Approach, optimized with "+chosen.algorithmType+" with a maximum runtime of approximately "+chosen.maxRuntimeInSeconds+" seconds!").replace("-1", "unlimited"));
            System.out.println("Instance name"+" & "+"Cost initial Solution"+" & "+"Cost optimized solution ("+chosen.algorithmType+")"+" & " + "Cost upper bound (100%)"+ "   \\\\");
            if(instance.getOptimalCost() > 0)
                System.out.println(instance.getName()+" & "+greedySolution.getCost()+" ("+(float)greedySolution.getCost()/(float)instance.getOptimalCost()*100+"%) & "+optimizedSolution.getCost()+" ("+(float)optimizedSolution.getCost()/(float)instance.getOptimalCost()*100+"%) & "+instance.getOptimalCost() + "   \\\\");
            else
                System.out.println(instance.getName()+" & "+greedySolution.getCost()+" & "+optimizedSolution.getCost()+" & "+ "   \\\\");
            System.out.println("\n Initial solution:\n"+greedySolution.toSol());
            System.out.println("\n Optimized solution:\n"+optimizedSolution.toSol());
        }
        
    }
}
